<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Admin | Pet Management</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <!--Bootstrap-->
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <!--Bootstrap DataTable-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="https://code.jquery.com/ui/1.12.1/themes/base/jquery-ui.css">
  <link rel="stylesheet" href="slider.css">
</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Pet</a>
      </li>
    </ul>

    <!-- Right navbar links -->
    <ul class="navbar-nav ml-auto">
      <!-- Navbar Search -->
      <li class="nav-item">
        <a class="nav-link" data-widget="navbar-search" href="#" role="button">
          <i class="fas fa-search"></i>
        </a>
        <div class="navbar-search-block">
          <form class="form-inline">
            <div class="input-group input-group-sm">
              <input class="form-control form-control-navbar" type="search" placeholder="Search" aria-label="Search">
              <div class="input-group-append">
                <button class="btn btn-navbar" type="submit">
                  <i class="fas fa-search"></i>
                </button>
                <button class="btn btn-navbar" type="button" data-widget="navbar-search">
                  <i class="fas fa-times"></i>
                </button>
              </div>
            </div>
          </form>
        </div>
      </li>

      <!-- Messages Dropdown Menu -->
      <li class="nav-item dropdown">
        <a class="nav-link" data-toggle="dropdown" href="#">
          <i class="far fa-comments"></i>
          <span class="badge badge-danger navbar-badge">3</span>
        </a>
        <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
          <a href="#" class="dropdown-item">
            <!-- Message Start -->
            <div class="media">
              <img src="dist/img/user1-128x128.jpg" alt="User Avatar" class="img-size-50 mr-3 img-circle">
              <div class="media-body">
                <h3 class="dropdown-item-title">
                  Brad Diesel
                  <span class="float-right text-sm text-danger"><i class="fas fa-star"></i></span>
                </h3>
                <p class="text-sm">Call me whenever you can...</p>
                <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
              </div>
            </div>
            <!-- Message End -->
          </a>
          <div class="dropdown-divider"></div>
          <a href="#" class="dropdown-item">
            <!-- Message Start -->
            <div class="media">
              <img src="dist/img/user8-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3">
              <div class="media-body">
                <h3 class="dropdown-item-title">
                  John Pierce
                  <span class="float-right text-sm text-muted"><i class="fas fa-star"></i></span>
                </h3>
                <p class="text-sm">I got your message bro</p>
                <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
              </div>
            </div>
            <!-- Message End -->
          </a>
          <div class="dropdown-divider"></div>
          <a href="#" class="dropdown-item">
            <!-- Message Start -->
            <div class="media">
              <img src="dist/img/user3-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3">
              <div class="media-body">
                <h3 class="dropdown-item-title">
                  Nora Silvester
                  <span class="float-right text-sm text-warning"><i class="fas fa-star"></i></span>
                </h3>
                <p class="text-sm">The subject goes here</p>
                <p class="text-sm text-muted"><i class="far fa-clock mr-1"></i> 4 Hours Ago</p>
              </div>
            </div>
            <!-- Message End -->
          </a>
          <div class="dropdown-divider"></div>
          <a href="#" class="dropdown-item dropdown-footer">See All Messages</a>
        </div>
      </li>
      <!-- Notifications Dropdown Menu -->
      <li class="nav-item dropdown">
        <a class="nav-link" data-toggle="dropdown" href="#">
          <i class="far fa-bell"></i>
          <span class="badge badge-warning navbar-badge">15</span>
        </a>
        <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
          <span class="dropdown-item dropdown-header">15 Notifications</span>
          <div class="dropdown-divider"></div>
          <a href="#" class="dropdown-item">
            <i class="fas fa-envelope mr-2"></i> 4 new messages
            <span class="float-right text-muted text-sm">3 mins</span>
          </a>
          <div class="dropdown-divider"></div>
          <a href="#" class="dropdown-item">
            <i class="fas fa-users mr-2"></i> 8 friend requests
            <span class="float-right text-muted text-sm">12 hours</span>
          </a>
          <div class="dropdown-divider"></div>
          <a href="#" class="dropdown-item">
            <i class="fas fa-file mr-2"></i> 3 new reports
            <span class="float-right text-muted text-sm">2 days</span>
          </a>
          <div class="dropdown-divider"></div>
          <a href="#" class="dropdown-item dropdown-footer">See All Notifications</a>
        </div>
      </li>
      <li class="nav-item">
        <a class="nav-link" data-widget="fullscreen" href="#" role="button">
          <i class="fas fa-expand-arrows-alt"></i>
        </a>
      </li>
      <li class="nav-item">
        <a class="nav-link" data-widget="control-sidebar" data-slide="true" href="#" role="button">
          <i class="fas fa-th-large"></i>
        </a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Admin</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">Huy Trần Quang</a>
        </div>
      </div>

      <!-- SidebarSearch Form -->
      <div class="form-inline">
        <div class="input-group" data-widget="sidebar-search">
          <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
          <div class="input-group-append">
            <button class="btn btn-sidebar">
              <i class="fas fa-search fa-fw"></i>
            </button>
          </div>
        </div>
      </div>
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6 text-bold">
            <h1>Quản lý thú cưng - Pet Management</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Pet Management</li>
            </ol>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="form-group d-flex">
        <button class="btn btn-success" id="btn-them-pet"><i class="fa fa-plus"></i>&nbsp; Thêm pet</button>
      </div>
      <div class="slider-box">
        <div>
            <span class="price-span">Prices</span>
        </div>
        <div class="price-div">
            <div class="ranger-label">
                <span>Ranger:</span>&nbsp;
            </div>
            <div class="price-label">
                $ <span id="min-price">0</span>
                <span class="seperator">-</span>
                $ <span id="max-price">1000</span>
            </div>
        </div>
        <div class="selector">
            <div class="price-slider">
                <div id="slider-range"
                    class="ui-slider ui-corner-all ui-slider-horizontal ui-widget ui-widget-content">
                </div>
            </div>
        </div>
    </div>
      <!-- Vùng Table -->
      <table id="pet-table" class="table table-bordered table-striped table-hover">
        <thead>
          <tr>
            <th>STT</th>
            <th>Type</th>
            <th>Name</th>
            <th>Description</th>
            <th>Ảnh</th>
            <th>Giá gốc</th>
            <th>Giá giảm</th>
            <th>Discount</th>
            <th>Ngày tạo</th>
            <th>Ngày cập nhập</th>
            <th>Action</th>
          </tr>
        </thead>
        <tbody>
  
        </tbody>
      </table>
    <!-- Vùng Modal -->

  <!-- Create pet modal -->
  <div>
    <div id="create-pet-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Create new pet</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <form>
              <div class="row form-group">
                <div class="col-sm-4">
                    <label>Type</label>
                </div>
                <div class="col-sm-8">
                    <select class="form-control" id="select-type">
                        <option value="Dog">Dog</option>
                        <option value="Cat">Cat</option>
                        <option value="Bird">Bird</option>
                        <option value="Fish">Fish</option>
                        <option value="Rabbit">Rabbit</option>
                    </select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label>Tên</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="inp-pet-name" 
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label>Thông tin</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="inp-des"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label>Ảnh</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="inp-img"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label>Giá gốc</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="inp-price"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label>Giá hữu nghị</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="inp-promoPrice"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label>Discount</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="inp-discount"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label class="col-form-label ">Ngày tạo</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" class="form-control transparent-background" id="inp-createDate" readonly>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label class="col-form-label ">Ngày cập nhập</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" class="form-control transparent-background" id="inp-updateDate" readonly>
                </div>
              </div>
            </form>
          </div>
          <div class="modal-footer">
            <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
            <button class="btn btn-primary" id="btn-create-pet">Create Pet</button>
          </div>
        </div>
      </div>
    </div>
  </div>
  <!-- Update pet modal -->
  <div>
    <div id="update-pet-modal" class="modal fade" tabindex="-1">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Update existing pet</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <form>
              <div class="row form-group">
                <div class="col-sm-4">
                    <label>Type</label>
                </div>
                <div class="col-sm-8">
                    <select class="form-control" id="selected-type">
                        <option value="Dog">Dog</option>
                        <option value="Cat">Cat</option>
                        <option value="Bird">Bird</option>
                        <option value="Fish">Fish</option>
                        <option value="Rabbit">Rabbit</option>
                    </select>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label>Tên</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-pet-name" 
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label>Thông tin</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-des"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label>Ảnh</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-img"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label>Giá gốc</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-price"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label>Giá hữu nghị</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-promoPrice"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label>Discount</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" id="input-discount"
                    class="form-control">
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label class="col-form-label ">Ngày tạo</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" class="form-control transparent-background" id="input-createDate" readonly>
                </div>
              </div>
              <div class="row form-group">
                <div class="col-sm-4">
                  <label class="col-form-label ">Ngày cập nhập</label>
                </div>
                <div class="col-sm-8">
                  <input type="text" class="form-control transparent-background" id="input-updateDate" readonly>
                </div>
              </div>
            </form>
          </div>
          <div class="modal-footer">
            <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
            <button class="btn btn-primary" id="btn-update-pet">Update Pet</button>
          </div>
        </div>
      </div>
    </div>
  </div>
   <!-- Delete confirm modal -->
   <div>
    <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="h5-modal-title">Delete Pet Confirmation</h5>
            <button class="close" data-dismiss="modal">&times;</button>
          </div>
          <div class="modal-body">
            <label>Bạn có chắc chắn muốn xóa pet này không?</label>
          </div>
          <div class="modal-footer">
            <button class="btn btn-danger" id="btn-confirm-delete-pet">Confirm</button>
            <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
          </div>
        </div>
      </div>
    </div>
  </div>
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b>  1.0
    </div>
    <strong>Copyright &copy; 2023 <a href="https://adminlte.io">Huy</a>.</strong> All rights reserved.
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/jqueryui/1.12.1/jquery-ui.min.js"></script>

<script>
$(document).ready(function () {
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "https://pucci-mart.onrender.com/api";
    const gCONTENT_TYPE = "application/json;charset=UTF-8";
    // Biến mảng hằng số chứa danh sách tên các thuộc tính
    const gPET_COLS = [
      "stt", 
      "type", 
      "name", 
      "description", 
      "imageUrl",  
      "price",
      "promotionPrice",
      "discount",
      "createdAt",
      "updatedAt",
      "id"
    ];
    // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
    const gSTT_PET_COL = 0;
    const gPET_TYPE_COL = 1;
    const gPET_NAME_COL = 2;
    const gPET_DES_COL = 3;
    const gPET_ANH_COL = 4;
    const gPET_PRICE_COL = 5;
    const gPET_PROMO_PRICE_COL = 6;
    const gPET_DISCOUNT_COL = 7;
    const gPET_CREATAT_COL = 8;
    const gPET_UPDATEAT_COL = 9;
    const gPET_ACTION_COL = 10;

    // Biến toàn cục để hiển lưu STT
    var gSTT = 1;
    // Khai báo DataTable & mapping collumns
    var gPetTable = $("#pet-table").DataTable({
      columns: [
        { data: gPET_COLS[gSTT_PET_COL] },
        { data: gPET_COLS[gPET_TYPE_COL] },
        { data: gPET_COLS[gPET_NAME_COL] },
        { data: gPET_COLS[gPET_DES_COL] },
        { data: gPET_COLS[gPET_ANH_COL] },
        { data: gPET_COLS[gPET_PRICE_COL] },
        { data: gPET_COLS[gPET_PROMO_PRICE_COL] },
        { data: gPET_COLS[gPET_DISCOUNT_COL] },
        { data: gPET_COLS[gPET_CREATAT_COL] },
        { data: gPET_COLS[gPET_UPDATEAT_COL] },
        { data: gPET_COLS[gPET_ACTION_COL] },
      ],
      columnDefs: [
        { // định nghĩa lại cột STT
          targets: gSTT_PET_COL,
          render: function () {
            return gSTT++;
          }
        },

        { // định nghĩa lại cột giá bán
          targets: gPET_PRICE_COL,
          render: function (paramData) {
            return "$ " + paramData
          }
        },

        { // định nghĩa lại cột giá giảm
          targets: gPET_PROMO_PRICE_COL,
          render: function (paramData) {
            return "$ " + paramData
          }
        },

        { // định nghĩa lại cột ảnh pet
          targets: gPET_ANH_COL,
          render: function (paramData) {
            return `<img src="${paramData}" alt="" style="width: 150px; height:150px">`
          }
        },

        { // định nghĩa lại cột action
          targets: gPET_ACTION_COL,
          render: function (paramData) {
            return `
              <img class="edit-pet" data-id=${paramData} src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
              <img class="delete-pet" data-id=${paramData} src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
            `
          }
        }
      ]
    });
    // Biến toàn cục để lưu các mảng giá trị
    var gPetArray = [];
    // Biến toàn cục để lưu id pet
    var gPetId = 0;
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    // thực hiện tải trang
    onPageLoading();
    // 2 - C: gán sự kiện Create - Thêm mới pet
    $("#btn-them-pet").on("click", function () {
      onBtnAddNewPetClick();
    });
     // 3 - U: gán sự kiện Update - Sửa 1 pet
     $("#pet-table").on("click", ".edit-pet", function () {
      onBtnEditPetClick(this);
    });
    // 4 - D: gán sự kiện delete - Xóa 1 pet
    $("#pet-table").on("click", ".delete-pet", function () {
      onBtnDeletePetClick(this);
    });

    //phần modal
    // gán sự kiện cho nút Create Pet (trên modal)
    $("#btn-create-pet").on("click", function () {
      onBtnCreatePetClick();
    });
    // gán sự kiện cho nút Update Pet (trên modal)
    $("#btn-update-pet").on("click", function () {
      onBtnUpdatePetClick();
    });
    // Gán sự kiện cho nút Confirm Delete pet (trên modal)
    $("#btn-confirm-delete-pet").on("click", function () {
      onBtnConfirmDeletePetClick();
    });
    //xử lý slider range và check box khi thay đổi thì lọc dữ liệu
    $("#slider-range").slider({
            range: true,
            values: [0, 1000],
            min: 0,
            max: 1000,
            step: 1,
            slide: function (event, ui) {
                $("#min-price").html(ui.values[0]);
                $("#max-price").html(ui.values[1]);
            },
            change: function (event, ui) {
              beginFilter(ui.values[0], ui.values[1]);
            },
        });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      //Read / Load pet to DataTable
      getAllPet();
    }
    // Hàm xử lý sự kiện khi nút Thêm mới đc click
    function onBtnAddNewPetClick() {
      // hiển thị modal trắng lên
      $("#create-pet-modal").modal("show");
    }
   
    // hàm xử lý sự kiện create contact button modal click
    function onBtnCreatePetClick() {
      // đối tượng contact sẽ được tạo mới
      var vPetObject = {
            type: "",                    // Trường type có giá trị thuộc danh sách sau: "Dog" || "Cat" || "Fish" || "Bird" || "Rabbit" 
            name: "",
            description: "",
            imageUrl: "",
            price: 0,
            promotionPrice: 0,
            discount: 0,
            createdAt:"",
            updatedAt: ""

        };
      // B1: Thu thập dữ liệu
      getCreatePetData(vPetObject);
      console.log(vPetObject);
      // B2: Validate insert
      var vIsPetValidate = validatePetData(vPetObject);
      if (vIsPetValidate) {
        // B3: insert pet
        $.ajax({
          url: gBASE_URL + "/pets",
          type: "POST",
          contentType: gCONTENT_TYPE,
          data: JSON.stringify(vPetObject),
          success: function (paramRes) {
            // B4: xử lý front-end
            handleInsertPetSuccess()
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          }
        });
      }
    }
    function onBtnEditPetClick(paramBtnEdit) {
      // lưu thông tin petID đang được edit vào biến toàn cục
      gPetId = $(paramBtnEdit).data("id");
      console.log(gPetId);
      $("#update-pet-modal").modal("show");
      // load dữ liệu vào các trường dữ liệu trong modal
      getPetByIdAndLoadToUpdateModal(gPetId);
    }
    function onBtnDeletePetClick(paramBtnDelete){
      //lưu thông tin petId đang được xóa vào biến
      gPetId = $(paramBtnDelete).data("id");
      console.log(gPetId);
      $("#delete-confirm-modal").modal("show");
    }
    // hàm xử lý sự kiện update pet modal click
    function onBtnUpdatePetClick() {
      // đối tượng contact sẽ được tạo mới
      var vPetObject = {
            type: "",                    // Trường type có giá trị thuộc danh sách sau: "Dog" || "Cat" || "Fish" || "Bird" || "Rabbit" 
            name: "",
            description: "",
            imageUrl: "",
            price: 0,
            promotionPrice: 0,
            discount: 0,
            createdAt: "",
            updatedAt: "",                    
        };
      // B1: Thu thập dữ liệu
      getUpdatePetData(vPetObject);
      console.log(vPetObject);
      // B2: Validate update
      var vIsPetValidate = validatePetData(vPetObject);
      if (vIsPetValidate) {
        // B3: update pet
        $.ajax({
          url: gBASE_URL + "/pets/" + gPetId,
          type: "PUT",
          contentType: gCONTENT_TYPE,
          data: JSON.stringify(vPetObject),
          success: function (paramRes) {
            // B4: xử lý front-end
            handleUpdatePetSuccess();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          }
        });
      }
    }
    // hàm xử lý sự kiện delete pet modal click
    function onBtnConfirmDeletePetClick(){
      "use strict";
      $.ajax({
          url: gBASE_URL + "/pets/" + gPetId,
          type: "DELETE",       
          success: function (paramRes) {
            // B4: xử lý front-end
            handleDeletePetSuccess();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          }
        });
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // hàm gọi api để lấy all danh sách pet
    function getAllPet() {
      $.ajax({
        url: gBASE_URL + "/pets/",
        type: "GET",
        success: function (paramPet) {
          gPetArray = paramPet;
          console.log(gPetArray);
          loadDataToPetTable(gPetArray.rows);
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        }
      });
    }
    /** load pet array to DataTable */
    function loadDataToPetTable(paramPetArray) {
      gSTT = 1;
      gPetTable.clear();
      gPetTable.rows.add(paramPetArray);
      gPetTable.draw();
    }

    function getDateToday() {
        var vToday = new Date();
        var vDay = vToday.getDate();
        var vMonth = vToday.getMonth() + 1;
        var vYear = vToday.getFullYear();
        if (vDay < 10) {
            vDay = '0' + vDay;
        }
        if (vMonth < 10) {
            vMonth = '0' + vMonth;
        }
        vToday = vDay + '/' + vMonth + '/' + vYear;
        return vToday;
    }
    // hàm thu thập dữ liệu để create pet
    function getCreatePetData(paramPetObj) {
      paramPetObj.type = $("#select-type").val();
      paramPetObj.name = $("#inp-pet-name").val().trim();
      paramPetObj.description = $("#inp-des").val().trim();
      paramPetObj.imageUrl = $("#inp-img").val().trim();
      paramPetObj.price = $("#inp-price").val();
      paramPetObj.promotionPrice = $("#inp-promoPrice").val();
      paramPetObj.discount = $("#inp-discount").val();
      paramPetObj.createdAt = getDateToday();
      paramPetObj.updatedAt = getDateToday();
    }
    // hàm validate data
    function validatePetData(paramPetObj) {
      if (paramPetObj.type == "") {
        alert("loại pet cần chọn");
        return false;
      }
      if (paramPetObj.name == "") {
        alert("Tên pet cần nhập");
        return false;
      }
      if (paramPetObj.description == "") {
        alert("Thông tin pet cần nhập");
        return false;
      }
      if (paramPetObj.price == "") {
        alert("Giá gốc cần nhập");
        return false;
      }
      if (paramPetObj.promotionPrice == "") {
        alert("Giá giảm cần nhập");
        return false;
      }
      return true;
    }
    // hàm xử lý hiển thị front-end khi thêm pet thành công
    function handleInsertPetSuccess() {
      alert("Thêm pet thành công!");
      getAllPet();
      resertCreatePetForm();
      $("#create-pet-modal").modal("hide");
    }
    // hàm xóa trắng form create pet
    function resertCreatePetForm() {
      $("#select-type").val();
      $("#inp-pet-name").val();
      $("#inp-des").val();
      $("#inp-img").val();
      $("#inp-price").val();
      $("#inp-promoPrice").val();
      $("#inp-discount").val();
      $("#inp-createDate").val();
      $("#inp-updateDate").val();
      
    }
    // hàm gọi api để lấy pet by id
    function getPetByIdAndLoadToUpdateModal(paramPetId){
      $.ajax({
        url: gBASE_URL + "/pets/" + paramPetId,
        type: "GET",
        success: function (paramPets) {
          console.log(paramPets);
          loadDataToUpdateModal(paramPets);
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        }
      });
    }
    // hàm show pet obj lên modal
   function loadDataToUpdateModal(paramPet) {
      $("#selected-type").val(paramPet.type);
      $("#input-pet-name").val(paramPet.name);
      $("#input-des").val(paramPet.description);
      $("#input-img").val(paramPet.imageUrl);
      $("#input-price").val(paramPet.price);
      $("#input-promoPrice").val(paramPet.promotionPrice);
      $("#input-discount").val(paramPet.discount);
      $("#input-createDate").val(paramPet.createdAt);
      $("#input-updateDate").val(paramPet.updatedAt);
    }
    
    // hàm thu thập dữ liệu để update pet
    function getUpdatePetData(paramPetObj) {
      paramPetObj.type = $("#selected-type").val();
      paramPetObj.name = $("#input-pet-name").val().trim();
      paramPetObj.description = $("#input-des").val();
      paramPetObj.imageUrl = $("#input-img").val().trim();
      paramPetObj.price = $("#input-price").val().trim();
      paramPetObj.promotionPrice = $("#input-promoPrice").val().trim();
      paramPetObj.discount = $("#input-discount").val();
      paramPetObj.createdAt = getDateToday;
      paramPetObj.updatedAt = getDateToday;
    }
    // hàm xử lý hiển thị front-end khi sửa pet thành công
    function handleUpdatePetSuccess() {
      alert("Sửa pet thành công!");
      getAllPet();
      resertUpdatePetForm();
      $("#update-pet-modal").modal("hide");
    }
    // hàm xóa trắng form update pet
    function resertUpdatePetForm() {
      $("#selected-type").val();
      $("#input-pet-name").val();
      $("#input-des").val();
      $("#input-img").val();
      $("#input-price").val();
      $("#input-promoPrice").val();
      $("#input-discount").val();
      $("#input-createDate").val();
      $("#input-updateDate").val();
    }
    function handleDeletePetSuccess(){
      // Hàm xử lý hiển thị front-end khi xóa pet thành công
      alert("Xóa pet thành công!");
      getAllPet();    
      $("#delete-confirm-modal").modal("hide");
    }
    function beginFilter(paramMinValue, paramMaxValue) {
            const vQueryParams = new URLSearchParams();
            vQueryParams.append('priceMin', paramMinValue);
            vQueryParams.append('priceMax', paramMaxValue);
            $.ajax({
                type: 'get',
                url: 'https://pucci-mart.onrender.com/api/pets?' + vQueryParams.toString(),
                dataType: 'json',
                success: function (paramData) {
                    console.log(paramData);
                    loadDataToPetTable(paramData.rows);
                },
                error: function (paramError) {
                    console.log(paramError);
                }
            });
        }
});
</script>
</body>
</html>
